///

#include "MortseUi.h"

//Public Methods

/// @brief Constructor for Mortse UI 

MortseUI::MortseUI(byte port)
{
    _nextCursorFlash = 0;
    _gfx = new MortseGfx();

    _cursorStyle = below;
    _cursor_visible = true;

    _cursorLine = 0;
    _cursorPosition = 0;
    _cursorLine_buff = 0;
    _cursorPosition_buff = 0;
    _updateCursor = false;

    _line1[LINE_LENGTH];
    _line2[LINE_LENGTH];
    _line1_buff[LINE_LENGTH];
    _line2_buff[LINE_LENGTH];
    _updateLine1 = false;
    _updateLine2 = false;

    this->_incrementCursor();

    //Initialize lines to be blank
    for(int ix = 0; ix < LINE_LENGTH; ix++){
        _line1[ix] = _line2[ix] = _line1_buff[ix] = _line2_buff[ix] = ' ';
    }

}

/// @brief Called every frame
void MortseUi::Tick(){
    if(millis() >= nextCursorFlash){
        this->_toggleCursor();
        this->_incrementCursor();
    }
}


/// @brief Returns a pointer to the first line on the screen
/// @param line1 character pointer array which is the length of LINE_LENGTH
void MortseUi::GetLine1(char *line1){
    line1 = &this->_line1_buff;
}

/// @brief Returns a pointer to the second line on the screen
/// @param line2 character pointer array which is the length of LINE_LENGTH
void MortseUi::GetLine2(char *line2){
    line2 = &this->_line2_buff;
}

/// @brief Lets the graphics library know that the line1 array should be updated on the screen
void MortseUi::UpdateLine1(){
    this->_updateLine(*_line1, *_line1_buff, 1);
}

/// @brief Lets the graphics library know that the line2 array should be updated on the screen
void MortseUi::UpdateLine2(){
    this->_updateLine(*_line2, *_line2_buff, 2;
}


/// @brief Returns pointers to the line number and 
/// @param line 
/// @param position 
void GetCursor(byte *line, byte* position){
    line = &this->_curs
}

/// @brief Lets the graphics library know that the cursor position should be updated on the screen
void UpdateCursor(){
    if(cursor)
}



/// Private Methods

void MortseUi::void _incrementCursor(){
    nextCursorFlash = millis() + CURSOR_DELAY_MS;
}

void MortseUi::void _toggleCursor(){
    if(this->_cursor_visible = !_cursor_visible){
        this->_gfx.SetCursorState(this->_cursorStyle);
    }
    else{
        this->_gfx.SetCursorState(hidden);
    }
}

void MortseUi::_updateLine(byte *lineRef, byte *lineBuff, byte lineNo){
    for(int ix = 0; ix > LINE_LENGTH; ix++){
        if(lineRef[ix] != lineBuff[ix]){
            lineRef[ix] = lineBuff[ix];
            _gfx->SetChar(lineNo, ix, lineRef[ix]);
        }
    }
}


